﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Sort_CellRange
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'c1NWindDataSet.Customers' table. You can move, or remove it, as needed.
            this.customersTableAdapter.Fill(this.c1NWindDataSet.Customers);
            //Hide focus rectangle, and paint the current cell using the Highlight style. Optional.
            this.c1FlexGrid1.FocusRect = C1.Win.C1FlexGrid.FocusRectEnum.None;
        }

        private void SortButton_Click(object sender, EventArgs e)
        {
            //Get CellRange from selection done via Mouse
            C1.Win.C1FlexGrid.CellRange cr = this.c1FlexGrid1.Selection;

            //Create a temporary Flex object 'fg'.
            var fg = new C1.Win.C1FlexGrid.C1FlexGrid();

            //Set the same number of rows and columns in temp object as in the CellRange of the actual grid.
            fg.Cols.Count = cr.c2 - cr.c1 + 1;
            fg.Cols.Fixed = 0;
            fg.Rows.Count = cr.r2 - cr.r1 + 1;
            fg.Rows.Fixed = 0;

            int _row = 0;
            int _col = 0;

            //Populate temp grid with data from selected range
            for (int i = cr.r1; i <= cr.r2; i++)
            {
                for (int j = cr.c1; j <= cr.c2; j++)
                {
                    fg[_row, _col] = this.c1FlexGrid1[i, j];
                    _col += 1;
                }
                _row += 1;
                _col = 0;
            }


            //Set Sort Type and the column index you wish sort to be implementd on.            
            //In this case, leftmost column of 'fg', and thereby leftmost column
            //of selected CellRange in actual grid, gets sorted in Ascending order.
            fg.Sort(C1.Win.C1FlexGrid.SortFlags.Ascending, 0);

            _row = 0;
            _col = 0;
            //Populate the selected range in actual grid with data from temp grid.
            for (int i = cr.r1; i <= cr.r2; i++)
            {
                for (int j = cr.c1; j <= cr.c2; j++)
                {
                    this.c1FlexGrid1[i, j] = fg[_row, _col];
                    _col += 1;
                }
                _row += 1;
                _col = 0;
            }
            //Object is not needed anymore.
            fg.Dispose();
        }
    }
}
